/*
 * This file is a part of Winix
 * and is not publicly distributed
 * 
 * Copyright (c) 2008-2010, Tomasz Sowa
 * All rights reserved.
 * 
 */
 
#ifndef headerfile_winix_plugins_ticket_ticket
#define headerfile_winix_plugins_ticket_ticket

#include <vector>
#include <string>
#include <algorithm>


namespace Ticket
{

struct Ticket
{
	struct TicketParam
	{
		int  param;
		long int_value; // changed to long (from int)
		std::wstring str_value;

		void Clear()
		{
			param     = 0;
			int_value = 0;
			str_value.clear();
		}

		TicketParam()
		{
			Clear();
		}
	};

	long file_id;
	std::vector<TicketParam> par_tab;
	
	// auxiliary object used during sorting
	unsigned long sort_id;

	void Clear()
	{
		file_id = -1;
		par_tab.clear();
		sort_id = 0;
	}

	struct Sort
	{
		bool operator()(const TicketParam & par1, const TicketParam & par2)
		{
			return par1.param < par2.param;
		}
	};

	void SortParTab()
	{
		std::sort(par_tab.begin(), par_tab.end(), Sort());
	}


	Ticket()
	{
		Clear();
	}
};


} // namespace


#endif
